SystemOrganization addCategory: #'StServer-KomServices'!
SystemOrganization addCategory: #'StServer-Scanners'!
SystemOrganization addCategory: #'StServer-Temp'!
SystemOrganization addCategory: #'StServer-Web'!

!String methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 14:47'!
asUTF16
	|t|
	t := WriteStream on: ''.
	UTF16TextConverter new nextPutAll: self toStream: t.
	^ t contents.! !

!String methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 14:47'!
asUTF8
	|t|
	t := WriteStream on: ''.
	UTF8TextConverter new nextPutAll: self toStream: t.
	^ t contents.! !

!String methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/14/2013 23:14'!
fromUTF8
	|src dst c t|
	src := ReadStream on: self.
	c := UTF8TextConverter new.
	dst := ''.
	[t := c nextFromStream: src.
	t isNil
		ifTrue: [false]
		ifFalse: [dst := dst, t asString. true]] whileTrue.
	^ dst.! !

!String methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 12:46'!
respondTo: aWebRequest
	|r|
	[r := aWebRequest statusLine,
	aWebRequest hServer,
	aWebRequest hContentType,
	crlf,
	'<html><head><title>', 'String', '</title></head>',
	'<body>', self , '</body></html>'.
	aWebRequest sendData: r]
		on: Error do: [:ex|].
	aWebRequest closeAndDestroy.! !

!Socket methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/19/2013 22:07'!
asBufferStream
	^ SocketReadStream new onEmpty: [:ers|
									ers size: (self receiveDataTimeout: 25 into: ers array).
									ers size = 0 ifTrue: [Error signal: 'Socket read error']].! !

!Socket methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/19/2011 23:24'!
webRequest
	^ WebRequest new socket: self.! !

FileStream subclass: #FileEmulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!FileEmulator methodsFor: 'file modes' stamp: 'NikolayKleptsov 8/21/2011 17:08'!
ascii! !

!FileEmulator methodsFor: 'testing' stamp: 'NikolayKleptsov 8/21/2011 17:11'!
atEnd
	^ false! !

!FileEmulator methodsFor: 'file modes' stamp: 'NikolayKleptsov 8/21/2011 17:07'!
binary! !

!FileEmulator methodsFor: 'file open/close' stamp: 'NikolayKleptsov 8/21/2011 16:50'!
close
! !

!FileEmulator methodsFor: 'file open/close' stamp: 'NikolayKleptsov 8/21/2011 17:08'!
closed
! !

!FileEmulator methodsFor: 'file accessing' stamp: 'NikolayKleptsov 8/21/2011 17:06'!
file! !

!FileEmulator methodsFor: 'file open/close' stamp: 'NikolayKleptsov 8/21/2011 17:08'!
flush
! !

!FileEmulator methodsFor: 'file accessing' stamp: 'NikolayKleptsov 8/21/2011 17:06'!
localName
	^'file emulator'! !

!FileEmulator methodsFor: 'file accessing' stamp: 'NikolayKleptsov 8/21/2011 17:06'!
name
	^'file emulator'! !

!FileEmulator methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/21/2011 17:04'!
nextPut: aByte! !

!FileEmulator methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/21/2011 16:52'!
nextPutAll: aSteam
! !

!FileEmulator methodsFor: 'positioning' stamp: 'NikolayKleptsov 8/21/2011 17:09'!
position
	^0! !

!FileEmulator methodsFor: 'positioning' stamp: 'NikolayKleptsov 8/21/2011 17:09'!
position: pos! !

!FileEmulator methodsFor: 'positioning' stamp: 'NikolayKleptsov 8/21/2011 17:13'!
printOn: aStream
	aStream nextPutAll: ' on '.! !

!FileEmulator methodsFor: 'file modes' stamp: 'NikolayKleptsov 8/21/2011 17:07'!
readOnly! !

!FileEmulator methodsFor: 'file modes' stamp: 'NikolayKleptsov 8/21/2011 17:07'!
readWrite! !

!FileEmulator methodsFor: 'file open/close' stamp: 'NikolayKleptsov 8/21/2011 17:09'!
reopen
! !

!FileEmulator methodsFor: 'positioning' stamp: 'NikolayKleptsov 8/21/2011 17:10'!
reset! !

!FileEmulator methodsFor: 'positioning' stamp: 'NikolayKleptsov 8/21/2011 17:10'!
setToEnd! !

!FileEmulator methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/21/2011 17:05'!
size
	^ 0! !

!FileEmulator methodsFor: 'positioning' stamp: 'NikolayKleptsov 8/21/2011 17:10'!
skip: n! !

!FileEmulator methodsFor: 'positioning' stamp: 'NikolayKleptsov 8/21/2011 17:10'!
trancate: pos! !

!FileStream methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/19/2011 22:40'!
allowPost: aWebRequest

	|file|
	
	aWebRequest 	recognizeFileName.
	aWebRequest 	recognizeDoubleCrlf.
	file := self directory forceNewFileNamed: aWebRequest fileName.
	file writeFromWebRequest: aWebRequest.
	self respondTo: aWebRequest.
	aWebRequest closeAndDestroy.! !

!FileStream methodsFor: '*StServer' stamp: 'NikolayKleptsov 12/29/2011 22:30'!
contentType
	^self mimeType asString.! !

!FileStream methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/19/2011 22:46'!
disablePost: aWebRequest

	|r f|
	
	aWebRequest 	recognizeFileName.
	aWebRequest 	recognizeDoubleCrlf.
	f := self directory forceNewFileNamed: 'temp.temp'.
	f writeFromWebRequest: aWebRequest.
	r :=
	'HTTP/1.0 403 Forbidden', lf,
	'Server: SmalltalkServer/1.0', lf,
	crlf.
	aWebRequest sendData: r.
	aWebRequest closeAndDestroy.! !

!FileStream methodsFor: '*StServer' stamp: 'NikolayKleptsov 12/29/2011 22:34'!
mimetype
	^ WebServer mimetypes
						at: (self localName copyAfterLast: $.)
						ifAbsent:[WebServer defaultMimetype].! !

!FileStream methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/19/2011 22:56'!
options: aWebRequest
	self directory options: aWebRequest.! !

!FileStream methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/19/2011 22:47'!
post: aWebRequest

	(self directory fileExists: '.allowPost.web')
		ifTrue: [self allowPost: aWebRequest]
		ifFalse: [self disablePost: aWebRequest].
		! !

!FileStream methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 12:01'!
respondTo: aWebRequest
	|r|	
	[r :=
	'HTTP/1.0 200 OK', lf,
	'Server: SmalltalkServer/1.0', lf,
	'Content-Type: ', self mimetype, lf,
	'Content-Length: ', self size asString, lf,
	aWebRequest outCookies, lf,
	crlf.
	self binary.
	aWebRequest sendData: r.
	aWebRequest sendStreamContents: self.]
		on: Error
		do: [:ex| Transcript show: 'FileStream: ', ex messageText; cr].
	aWebRequest closeAndDestroy.! !

!FileStream methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/19/2011 22:39'!
writeFromWebRequest: aWebRequest
	self binary.
	aWebRequest recognizeAndWriteToFile: self.
	self close.! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 23:09'!
allowPost: aWebRequest
	|file|	
	[aWebRequest 	recognizeFileName.
	aWebRequest 	recognizeDoubleCrlf.
	file := (self newFileReference: aWebRequest fileName) writeStream.
	file writeFromWebRequest: aWebRequest.
	self respondTo: aWebRequest]
		on: Error do: [:ex|
						file isNil ifFalse: [file close.].
						Transcript show: 'Error server file upload: ', ex messageText; cr.
						aWebRequest closeAndDestroy].
	aWebRequest closeAndDestroy.! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 16:24'!
defaultRespondTo: aWebRequest
	|r fs ds s|
	r := aWebRequest statusLine,
	aWebRequest hServer,
	'Allow: GET, POST', lf,
	'Content-Type: text/html; charset=utf-8', lf,
	crlf.
	r := r, '<html><head><title>', aWebRequest currentResourceSelector,
	'</title></head><body>',
	'<h4>Index of ', aWebRequest stringPath, '</h4>'.
	r := r, self uploadCod.
	r :=  r, aWebRequest parentDirectoryHref, '<br>'.
	ds := self directories.
	ds do: [:dr|
		r := r, (aWebRequest hrefOf: dr entry basename), '<br>'].
	fs := self files.
	fs do: [:file| 
		r := r, (aWebRequest hrefOf: file entry basename), '<br>'].
	r := r, '</body></html>'.
	aWebRequest sendData: r asUTF8.
	aWebRequest closeAndDestroy.! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 15:17'!
directoryRespondTo: aWebRequest
	|r|
	r := aWebRequest nextResourceSelector.
	r = 'defaultResource'
		ifTrue: [self defaultRespondTo: aWebRequest]
		ifFalse: [aWebRequest request: (self newFileReference: r)].! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 16:36'!
disablePost: aWebRequest
	|r f|	
	"aWebRequest 	recognizeFileName.
	aWebRequest 	recognizeDoubleCrlf.
	f := FileEmulator new.
	f writeFromWebRequest: aWebRequest.
	self respondTo: aWebRequest."
	r :=
	'HTTP/1.0 200 OK', lf,
	'Server: SmalltalkServer/1.0', lf,
	'Content-Type: text/html', lf
	crlf.
	aWebRequest sendData: r.
	aWebRequest closeAndDestroy.! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 12:02'!
fileRespondTo: aWebRequest
	|file|
	file := self readStream.
	aWebRequest request: file.! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 11:45'!
newFileReference: aSegmentOrFileName
	|fr|
	fr := (path newPlus: aSegmentOrFileName) asFileReference.
	^ fr.! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 21:37'!
post: aWebRequest
	|r|
	r := aWebRequest nextResourceSelector.
	r = 'defaultResource'
		ifTrue: [(self newFileReference: '.allowPost.web') exists
						ifTrue: [self allowPost: aWebRequest]
						ifFalse: [self disablePost: aWebRequest]. ]
		ifFalse: [aWebRequest request: (self newFileReference: r)].! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/12/2013 23:57'!
respondTo: aWebRequest
	self isFile
		ifTrue: [self fileRespondTo: aWebRequest]
		ifFalse: [self directoryRespondTo: aWebRequest].! !

!FileReference methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 16:23'!
uploadCod
	|r|
	(self newFileReference: '.allowPost.web') exists ifFalse: [^ ''].
	r :=
	'<form enctype="multipart/form-data" method="post">',
		'<h4>Upload your file</h4>',
		'<p><input type="file" name="f">',
			'<input type="submit" value="upload"></p>',
	'</form>'.
	^ r.! !

Object subclass: #ABuffer
	instanceVariableNames: 'size array index onFullBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Scanners'!

!ABuffer methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/15/2013 20:59'!
array
	^ array! !

!ABuffer methodsFor: 'buffering' stamp: 'NikolayKleptsov 8/16/2011 16:47'!
flush
	onFullBuffer value: (array copyFrom: 1 to: index) .
	index := 0.! !

!ABuffer methodsFor: 'buffering' stamp: 'NikolayKleptsov 8/16/2011 16:32'!
flushAll
	onFullBuffer value: array.
	index := 0.! !

!ABuffer methodsFor: 'buffering' stamp: 'NikolayKleptsov 8/20/2011 16:37'!
flushInto: aBuffer
	1 to: index do: [:i| aBuffer nextPut: (array at: i)].
	index := 0.! !

!ABuffer methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 16:23'!
index
	^ index! !

!ABuffer methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 16:23'!
index: anIndex
	index := anIndex! !

!ABuffer methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 8/16/2011 16:25'!
initialize
	super initialize.
	index := 0.
	self size: 2000.! !

!ABuffer methodsFor: 'buffering' stamp: 'NikolayKleptsov 8/19/2011 20:06'!
nextPut: anObject
	index := index + 1.
	index > size ifTrue: [self flushAll. index := 1].
	array at: index put: anObject asInteger.! !

!ABuffer methodsFor: 'buffering' stamp: 'NikolayKleptsov 8/19/2011 19:37'!
nextPutAll: anObject
	anObject do: [:el| self nextPut: el]! !

!ABuffer methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 16:26'!
onFullBuffer: anBlock
	onFullBuffer := anBlock.! !

!ABuffer methodsFor: 'buffering' stamp: 'NikolayKleptsov 8/17/2011 22:19'!
reset
	index := 0.! !

!ABuffer methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 19:49'!
size: aSize
	size := aSize.
	array := ByteArray new: aSize
	! !

Object subclass: #BufferStream
	instanceVariableNames: 'socket cache index size mark source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!BufferStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 5/1/2011 00:15'!
cache

	^ cache.! !

!BufferStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 5/1/2011 00:13'!
cache: aString

	cache := aString.
	size := cache size.
	index := 0.! !

!BufferStream methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 8/19/2011 17:58'!
initialize

	super initialize.
	self initializeCache.
	self initializeIndex.
	self initializeSize.! !

!BufferStream methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 4/28/2011 14:10'!
initializeCache

	cache := ''.! !

!BufferStream methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 4/28/2011 14:11'!
initializeIndex

	index := 0.! !

!BufferStream methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 4/28/2011 14:56'!
initializeSize

	size := 0.! !

!BufferStream methodsFor: 'reading' stamp: 'NikolayKleptsov 7/26/2011 22:47'!
next

	index = size
		ifTrue: [self receiveData].
	index := index + 1.
	^ cache at: index.

! !

!BufferStream methodsFor: 'reading' stamp: 'NikolayKleptsov 4/30/2011 23:50'!
next: aCount

	| t |
	
	t := ''.
	aCount timesRepeat: [t := t, self next].
	^ t.
! !

!BufferStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 18:16'!
receiveData

	| t |

	t := source value.
	cache := cache last: cache size - index.
	cache := cache, t.
	size := cache size.
	index := 0.! !

!BufferStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 4/28/2011 14:03'!
socket

	^ socket! !

!BufferStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/18/2011 00:16'!
socket: aSocket

	socket := aSocket.
	source := [aSocket receiveData].! !

!BufferStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 20:15'!
source
	^ source! !

!BufferStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 20:15'!
source: aSourceBlock
	source := aSourceBlock! !

Object subclass: #Directory
	instanceVariableNames: 'path directory isRelative'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!Directory methodsFor: 'directory type' stamp: 'NikolayKleptsov 10/10/2011 10:39'!
absoluteDirectory
	directory := [FileDirectory on: path].
	isRelative := false.! !

!Directory methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/10/2011 10:40'!
directory
	^ directory value.! !

!Directory methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/10/2011 10:46'!
initialize
	super initialize.
	self initializeDirectory.
	! !

!Directory methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/10/2011 10:46'!
initializeDirectory
	self relativeDirectory.! !

!Directory methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/10/2011 10:34'!
path
	^ path! !

!Directory methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/10/2011 10:34'!
path: aPath
	path := aPath! !

!Directory methodsFor: 'directory type' stamp: 'NikolayKleptsov 10/10/2011 10:39'!
relativeDirectory
	directory := [FileDirectory default directoryNamed: path].
	isRelative := true.! !

Object subclass: #FileDirectory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!FileDirectory methodsFor: 'StServer' stamp: 'NikolayKleptsov 1/1/2012 18:57'!
defaultResource

	|fileName|
	
	fileName := 'index.html'.
	(self fileExists: fileName)
		ifTrue: [^ self readOnlyFileNamed: fileName.]
		ifFalse: [^ DirectoryBrowserResponse new directory: self].! !

!FileDirectory methodsFor: 'StServer' stamp: 'NikolayKleptsov 8/3/2011 18:09'!
fileDirectoryOptions: aWebRequest

	|r|
	
	r := 'HTTP/1.0 200 OK', String lf,
	self serverNameHead, String lf,
	'Allow: GET', String lf,
	String crlf,
	'<html><head><title>Allow: GET</title><head>',
	'<body><h1>Allow: GET</h1></body></html>'.
	aWebRequest socket sendData: r.! !

!FileDirectory methodsFor: 'StServer' stamp: 'NikolayKleptsov 8/3/2011 18:13'!
options: aWebRequest

	|r|
	
	aWebRequest path size = 0
				ifTrue: [self fileDirectoryOptions: aWebRequest]
				ifFalse: [(self resource: aWebRequest path removeFirst) options: aWebRequest].! !

!FileDirectory methodsFor: 'StServer' stamp: 'NikolayKleptsov 8/3/2011 21:05'!
post: aWebRequest

	self respondTo: aWebRequest! !

!FileDirectory methodsFor: 'StServer' stamp: 'NikolayKleptsov 1/1/2012 19:26'!
readOnlyFileOrDirectoryName: aFileOrDirectoryName
	|e|
	aFileOrDirectoryName = 'defaultResource'
		ifTrue: [^ self defaultResource].
	e := self directoryEntryFor: aFileOrDirectoryName.
	e ifNil: [^ nil].
	e isDirectory ifTrue: [^ self directoryNamed: aFileOrDirectoryName].
	^ self readOnlyFileNamed: aFileOrDirectoryName.! !

!FileDirectory methodsFor: 'StServer' stamp: 'NikolayKleptsov 1/1/2012 19:30'!
resource: aName
	|r|	
	r := self readOnlyFileOrDirectoryName: aName.
	r ifNil: [r := NotFoundResponse new].
	^ r.! !

!FileDirectory methodsFor: 'StServer' stamp: 'NikolayKleptsov 1/1/2012 19:31'!
respondTo: aWebRequest
	|r|
	r := aWebRequest nextResourceSelector.
	r := self resource: r.
	aWebRequest request: r.! !

Object subclass: #HttpRequestRules
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Scanners'!

HttpRequestRules class
	instanceVariableNames: 'percentEncodingTable GetTrm PostTrm EndStm NotAllow StartTrm OptionsTrm SpacesBeforeResourceTrm SegmentTrm PercentTrm SpaceBeforeVersionTrm VersionTrm StartHeadsTrm HostTrm UserAgentTrm CrLfTrm ReadingVersionTrm ReadingHostTrm'!

HttpRequestRules class
	instanceVariableNames: 'percentEncodingTable GetTrm PostTrm EndStm NotAllow StartTrm OptionsTrm SpacesBeforeResourceTrm SegmentTrm PercentTrm SpaceBeforeVersionTrm VersionTrm StartHeadsTrm HostTrm UserAgentTrm CrLfTrm ReadingVersionTrm ReadingHostTrm'!

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/17/2013 21:07'!
boundary

	|s0 s1 s2 s3 s4 s5 s6 s7 s8 s9 s10 s11 s12 s13 s14 index endStm|
	
	index := 0.
	endStm := ScStatement end.
	s14 := [:char :dest| ((char codePoint = 13) | (char codePoint =10)) 
									ifTrue: [endStm]
									ifFalse: [index := index + 1.
											index >15000 ifTrue: [endStm] ifFalse: [s0 value: char value: dest]]].
	s13 := [:char :dest| ((char codePoint = 13) | (char codePoint =10))  ifTrue: [s14] ifFalse: [s0 value: char value: dest]].
	s12 := [:char :dest| ((char codePoint = 13) | (char codePoint =10))  ifTrue: [s14] ifFalse: [s0 value: char value: dest]].
	s11 := [:char :dest| ((char codePoint = 13) | (char codePoint =10)) ifTrue: [s12] ifFalse: [s0]].
	
	s10 := [:char :dest| char = Character cr ifTrue: [s11] ifFalse: [dest addCharacterAtBoundary: char. s10]].
	s8 := [:char :dest| char = $= ifTrue: [s10] ifFalse: [s11 value: char value: dest]].
	s7 := [:char :dest| char = $y ifTrue: [s8] ifFalse: [s11 value: char value: dest]].
	s6 := [:char :dest| char = $r ifTrue: [s7] ifFalse: [s11 value: char value: dest]].
	s5 := [:char :dest| char = $a ifTrue: [s6] ifFalse: [s11 value: char value: dest]].
	s4 := [:char :dest| char = $d ifTrue: [s5] ifFalse: [s11 value: char value: dest]].
	s3 := [:char :dest| char = $n ifTrue: [s4] ifFalse: [s11 value: char value: dest]].
	s2 := [:char :dest| char = $u ifTrue: [s3] ifFalse: [s11 value: char value: dest]].
	s1 := [:char :dest| char = $o ifTrue: [s2] ifFalse: [s11 value: char value: dest]].
	s0 := [:char :dest| char = $b ifTrue: [s1] ifFalse: [s11 value: char value: dest]].
	^ s0.! !

!HttpRequestRules class methodsFor: 'heads' stamp: 'NikolayKleptsov 1/20/2013 23:19'!
crLfTrm
	CrLfTrm isNil ifTrue: [
		CrLfTrm := KeyTerminal new.
		CrLfTrm
			onFailure: [:char :ctx| ctx unmark. self startHeadsTrm ];
			onSuccess: [:char :ctx| ctx unmark. self endStm ];
			key: cr, lf].! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/17/2013 21:08'!
crlf

	|s1 s2 s3 stmEnd|
	
	stmEnd := ScStatement end.
	s3 := [:char :dest| char = Character cr ifTrue: [stmEnd] ifFalse: [s1 value: char value: dest]].
	s2 := [:char :dest| char = Character lf ifTrue:[stmEnd] ifFalse: [s3 value: char value: dest]].
	s1 := [:char :dest| char = Character cr ifTrue:[s2] ifFalse:[s1]].
	^ s1.! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/17/2013 21:08'!
doubleCrlf

	|s1 s2 s3 s4 stmEnd|
	
	stmEnd := ScStatement end.
	s4 := [:char :dest| char =Character lf ifTrue: [stmEnd] ifFalse: [s1 value: char value: dest]].
	s3 := [:char :dest| char = Character cr ifTrue: [s4] ifFalse: [s1 value: char value: dest]].
	s2 := [:char :dest| char = Character lf ifTrue:[s3] ifFalse: [s1 value: char value: dest]].
	s1 := [:char :dest| char = Character cr ifTrue:[s2] ifFalse:[s1]].
	^ s1.! !

!HttpRequestRules class methodsFor: 'statusLineScanning' stamp: 'NikolayKleptsov 1/20/2013 00:35'!
endStm
	EndStm isNil ifTrue: [
		EndStm := ScStatement end].
	^ EndStm.! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/17/2013 21:09'!
fileName

	|s1 s2 s3 s4 s5 s6 s7 s8 s9 s10 s11 s12 s13 stmEnd|
	
	stmEnd := ScStatement end.
	s11 := [:char :dest| char = $"
			ifTrue:[dest fileName: dest fileName fromUTF8. stmEnd]
			ifFalse: [dest addCharacterAtFileName: char. s11]].
	s10 := [:char :dest| char = $" ifTrue:[s11] ifFalse: [s1 value: char value: dest]].
	s9 := [:char :dest| char = $= ifTrue:[s10] ifFalse: [s1 value: char value: dest]].
	s8 := [:char :dest| char = $e ifTrue:[s9] ifFalse: [s1 value: char value: dest]].
	s7 := [:char :dest| char = $m ifTrue:[s8] ifFalse: [s1 value: char value: dest]].
	s6 := [:char :dest| char = $a ifTrue:[s7] ifFalse: [s1 value: char value: dest]].
	s5 := [:char :dest| char = $n ifTrue:[s6] ifFalse: [s1 value: char value: dest]].
	s4 := [:char :dest| char = $e ifTrue:[s5] ifFalse: [s1 value: char value: dest]].
	s3 := [:char :dest| char = $l ifTrue:[s4] ifFalse: [s1 value: char value: dest]].
	s2 := [:char :dest| char = $i ifTrue:[s3] ifFalse: [s1 value: char value: dest]].
	s1 := [:char :dest| char = $f ifTrue:[s2] ifFalse: [s1]].
	^ s1.! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/17/2013 21:10'!
firstLine

	|s0 s1 s2 s7 s20 stmEnd|
	
	stmEnd := ScStatement end.
	s20 := [:char :dest| dest method: #notAllow:. stmEnd].
	s7 := self resource.
	s2 := [:char :dest| char = $T ifTrue: [dest method: #respondTo:. s7] ifFalse: [s20]].	
	s1 := [:char :dest| char = $E ifTrue: [s2] ifFalse: [s20]].	
	s0 := [:char :dest| char = $G ifTrue: [s1] ifFalse: [(self post: s7) value: char value: dest]].
	^ s0.! !

!HttpRequestRules class methodsFor: 'statusLineScanning' stamp: 'NikolayKleptsov 1/20/2013 22:37'!
getTrm
	GetTrm isNil ifTrue: [
		GetTrm := KeyTerminal new.
		GetTrm onFailure: [:char :ctx| ctx goToMark. self postTrm];
			onSuccess: [:char :ctx|
							ctx unmark.
							ctx method: #respondTo:.
							self spacesBeforeResourceTrm.];
			onStep: [:char :ctx| ];
			key: 'GET'].
	^ GetTrm! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/17/2013 21:11'!
head: aScanner1

	| s0 s1 s2 s3 s4 s5 s6 s7 stmEnd|
	
	stmEnd := ScStatement end.
	s7 := [:char :dest| dest method: #notAllow:. stmEnd].
	s3 := [:char :dest| char = $D ifTrue:[s4] ifFalse:[s7 value: char value: dest]].
	s2 := [:char :dest| char = $A ifTrue: [s3] ifFalse: [s7 value: char value: dest]].
	s1 := [:char :dest| char = $E ifTrue: [s2] ifFalse: [s7 value: char value: dest]].
	s0 := [:char :dest| char = $H ifTrue: [s1] ifFalse: [s7 value: char value: dest]].
	^ s0.! !

!HttpRequestRules class methodsFor: 'heads' stamp: 'NikolayKleptsov 1/20/2013 23:20'!
heads
	^ self "startHeadsTrm" boundary.! !

!HttpRequestRules class methodsFor: 'heads' stamp: 'NikolayKleptsov 1/20/2013 22:54'!
hostTrm
	HostTrm isNil ifTrue: [
		HostTrm := KeyTerminal new.
		HostTrm
			onFailure: [:char :ctx| ctx goToMark. self crLfTrm"self userAgentTrm"];
			onSuccess: [:char :ctx| self readingHostTrm];
			onStep: [:char :ctx| ];
			key: 'Host:'].
	^ HostTrm.
! !

!HttpRequestRules class methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 8/21/2011 22:42'!
initializePercentEncoding
	percentEncodingTable := nil.
	self percentEncodingTable.! !

!HttpRequestRules class methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 1/20/2013 22:08'!
initializeTrm
	EndStm := nil.
	GetTrm := nil.
	NotAllow := nil.
	OptionsTrm := nil.
	PostTrm := nil.
	StartTrm := nil.
	PercentTrm := nil.
	SegmentTrm := nil.
	SpaceBeforeVersionTrm := nil.
	SpacesBeforeResourceTrm := nil.
	VersionTrm := nil.
	CrLfTrm := nil.
	HostTrm := nil.
	StartHeadsTrm := nil.
	UserAgentTrm := nil.
	ReadingVersionTrm := nil.
	ReadingHostTrm := nil.
! !

!HttpRequestRules class methodsFor: 'statusLineScanning' stamp: 'NikolayKleptsov 1/20/2013 13:23'!
notAllow
	NotAllow isNil ifTrue: [
		NotAllow :=  [:char :ctx|
						ctx method: #notAllow:.
						ctx unmark.
						self spacesBeforeResourceTrm]].
	^ NotAllow.! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/17/2013 21:12'!
options: aScanner1

	| s0 s1 s2 s3 s4 s5 s6 s7 stmEnd|
	
	stmEnd := ScStatement end.
	s7 := [:char :dest| dest method: #notAllow:. stmEnd].
	s6 := [:char :dest| char = $S ifTrue:[dest method: #options:. aScanner1] ifFalse:[s7 value: char value: dest]].
	s5 := [:char :dest| char = $N ifTrue:[s6] ifFalse:[s7 value: char value: dest]].
	s4 := [:char :dest| char = $O ifTrue:[s5] ifFalse:[s7 value: char value: dest]].
	s3 := [:char :dest| char = $I ifTrue:[s4] ifFalse:[s7 value: char value: dest]].
	s2 := [:char :dest| char = $T ifTrue: [s3] ifFalse: [s7 value: char value: dest]].
	s1 := [:char :dest| char = $P ifTrue: [s2] ifFalse: [s7 value: char value: dest]].
	s0 := [:char :dest| char = $O ifTrue: [s1] ifFalse: [s7 value: char value: dest]].
	^ s0.! !

!HttpRequestRules class methodsFor: 'statusLineScanning' stamp: 'NikolayKleptsov 1/20/2013 21:15'!
optionsTrm
	OptionsTrm isNil ifTrue: [
		OptionsTrm := KeyTerminal new.
		OptionsTrm
			onFailure: [:char :ctx| ctx goToMark. self notAllow];
			onSuccess: [:char :ctx|
							ctx method: #options:.
							self notAllow value: char value: ctx];
			onStep: [:char :ctx| ];
			key: 'OPTIONS'].
	^ OptionsTrm! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 8/21/2011 23:08'!
percentEncoding: aNextScanner
	|s1 s2 s3 s4 s5 b1 b3 c1 c2|
	s1 := [:char :cont| b1 := char. s2].
	s2 := [:char :cont| |index nextScanner|
			c1 := Number readFrom: (String with: b1 with: char) base: 16.
			index := self percentEncodingTable at: c1 ifAbsent: [nil].
			index ifNil: [nextScanner := s3]
				ifNotNil: [cont addCharacterAtPath: index.
							nextScanner := aNextScanner].
			nextScanner].
	s3 := [:char :cont| char == $%
						ifTrue: [s4]
						ifFalse: [aNextScanner value: char value: cont]].
	s4 := [:char :cont| b3 := char. s5].
	s5 := [:char :cont| 
			c2 := Number readFrom: (String with: b3 with: char) base: 16.
			cont addCharacterAtPath:
					(UTF8TextConverter new nextFromStream:
						(ReadStream on: 
							(String with: (Character value: c1) with: (Character value: c2))
						)
					).
			aNextScanner].
	^ s1.! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 8/21/2011 22:40'!
percentEncodingTable
	percentEncodingTable ifNil: [
		percentEncodingTable := IdentityDictionary new: 130.
		percentEncodingTable
			at: 16r22 put: $";
			at: 16r23 put: $#;
			at: 16r25 put: $%;
			at: 16r26 put: $&;
			at: 16r27 put: $';
			at: 16r2a put: $*;
			at: 16r2c put: $,;
			at: 16r3a put: $:;
			at: 16r3b put: $;;
			at: 16r3c put: $<;
			at: 16r3e put: $>;
			at: 16r3f put: $?;
			at: 16r5b put: $[;
			at: 16r5d put: $];
			at: 16r5e put: $^;
			at: 16r60 put: $`;
			at: 16r7b put: ${;
			at: 16r7c put: $|;
			at: 16r7d put: $};
			at: 16r20 put: Character space].
	^ percentEncodingTable.! !

!HttpRequestRules class methodsFor: 'statusLineScanning-resource' stamp: 'NikolayKleptsov 1/20/2013 19:19'!
percentTrm
	PercentTrm isNil ifTrue: [
		PercentTrm := Terminal new.
		PercentTrm
			key: $%;
			onFailure: [:aChar :ctx|
						ctx goToMark.
						self spaceBeforeVersionTrm];
			onSuccess: [:aChar :ctx|
							self percentEncoding: self segmentTrm]].
	^ PercentTrm! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/17/2013 21:13'!
post: aScanner

	|s1 s2 s3 s4 s5 stmEnd|
	
	stmEnd := ScStatement end.
	s5 := [:char :dest| dest method: #notAllow:. stmEnd].
	s4 := [:char :dest| char = $T ifTrue: [dest method: #post:. aScanner] ifFalse: [s5]].
	s3 := [:char :dest| char = $S ifTrue: [s4] ifFalse: [s5]].	
	s2 := [:char :dest| char = $O ifTrue: [s3] ifFalse: [s5]].
	s1 := [:char :dest| char = $P ifTrue: [s2]
									ifFalse: [(self options: aScanner) value: char value: dest]].
	^ s1.! !

!HttpRequestRules class methodsFor: 'statusLineScanning' stamp: 'NikolayKleptsov 1/20/2013 21:13'!
postTrm
	PostTrm isNil ifTrue: [
		PostTrm := KeyTerminal new.
		PostTrm onFailure: [:char :ctx| ctx goToMark. self optionsTrm];
			onSuccess: [:char :ctx|
							ctx unmark.
							ctx method: #post:.
							self spacesBeforeResourceTrm];
			onStep: [:char :ctx| ];
			key: 'POST'].
	^ PostTrm! !

!HttpRequestRules class methodsFor: 'heads' stamp: 'NikolayKleptsov 1/20/2013 23:10'!
readingHostTrm
	ReadingHostTrm isNil ifTrue: [
		ReadingHostTrm := KeyTerminal new.
		ReadingHostTrm
			onFailure: [:char :ctx|
							ctx hHost: ctx hHost, char asString.
							self readingHostTrm];
			onSuccess: [:char :ctx| self crLfTrm];
			onStep: [:char :ctx| ];
			key: cr, lf ].
	^ ReadingHostTrm.! !

!HttpRequestRules class methodsFor: 'statusLineScanning-version' stamp: 'NikolayKleptsov 1/20/2013 22:50'!
readingVersionTrm
	ReadingVersionTrm isNil ifTrue: [
		ReadingVersionTrm := KeyTerminal new.
		ReadingVersionTrm
			onFailure: [:char :ctx|
						ctx httpVersion: ctx httpVersion, char asString.
						self readingVersionTrm];
			onSuccess: [:char :ctx| self heads];
			onStep: [:char :ctx| ];
			key: cr, lf].
	^ ReadingVersionTrm! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/20/2013 12:35'!
resource

	|s7 s8 s9 s10 s11 s12 s13 s14 t|
	
	s14 := [:char :dest| t := Number readFrom: (t , char asString) base: 16.
				dest addCharacterAtPath: (Character value: t). s8].
			
	s13 := [:char :dest| t := char asString. s14].	
	s12 := self heads.
	s11 := [:char :dest| char = Character space
									ifTrue: [s12]
									ifFalse: [dest addCharacterAtPath: char. s8]].
	s10 := [:char :dest| char = $? ifTrue: [s12] "change" ifFalse: [s11 value: char value: dest]].
	s9 := [:char :dest| char = $% ifTrue: [self percentEncoding: s8]
									  ifFalse: [s10 value: char value: dest]].
	s8 := [:char :dest| char = $/
								ifTrue: [dest addPath. s8]
								ifFalse: [s9 value: char value: dest]].
	
	s7 := [:char :dest| char = Character space
										ifTrue: [s7]
										ifFalse: [s8 value: char value: dest]].
	^ s7.! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/20/2013 12:35'!
resource2

	|s7 s8 s9 s10 s11 s12 s13 s14 t|
	
	s14 := [:char :dest| t := Number readFrom: (t , char asString) base: 16.
				dest addCharacterAtPath: (Character value: t). s8].
			
	s13 := [:char :dest| t := char asString. s14].	
	s12 := self heads.
	s11 := [:char :dest| char = Character space
									ifTrue: [s12]
									ifFalse: [dest addCharacterAtPath: char. s8]].
	s10 := [:char :dest| char = $? ifTrue: [s12] "change" ifFalse: [s11 value: char value: dest]].
	s9 := [:char :dest| char = $% ifTrue: [self percentEncoding: s8]
									  ifFalse: [s10 value: char value: dest]].
	s8 := [:char :dest| char = $/
								ifTrue: [dest addPath. s8]
								ifFalse: [s9 value: char value: dest]].
	
	s7 := [:char :dest| char = Character space
										ifTrue: [s7]
										ifFalse: [s8 value: char value: dest]].
	^ s8.! !

!HttpRequestRules class methodsFor: 'statusLineScanning-resource' stamp: 'NikolayKleptsov 1/20/2013 20:17'!
segmentTrm
		SegmentTrm isNil ifTrue: [
			SegmentTrm := Terminal new.
			SegmentTrm
				key:  $/;
				onFailure: [:aChar :ctx|
								"self percentTrm"
								self spaceBeforeVersionTrm value: aChar value: ctx];
				onSuccess: [:aChar :ctx|
								ctx addPath.
								SegmentTrm]].
		^ SegmentTrm! !

!HttpRequestRules class methodsFor: 'statusLineScanning-resource' stamp: 'NikolayKleptsov 1/20/2013 22:44'!
spaceBeforeVersionTrm
	SpaceBeforeVersionTrm isNil ifTrue: [
		SpaceBeforeVersionTrm := Terminal new.
		SpaceBeforeVersionTrm
			key: Character space;
			onSuccess: [:aChar :ctx| self versionTrm];
			onFailure: [:aChar :ctx|
							ctx addCharacterAtPath: aChar.
							self segmentTrm]].
	^ SpaceBeforeVersionTrm.! !

!HttpRequestRules class methodsFor: 'statusLineScanning-resource' stamp: 'NikolayKleptsov 1/20/2013 22:42'!
spacesBeforeResourceTrm
	SpacesBeforeResourceTrm isNil ifTrue: [
		SpacesBeforeResourceTrm := KeyTerminal new.
		SpacesBeforeResourceTrm
			onSuccess: [:char :ctx| self endStm];
			onFailure: [:char :ctx| self segmentTrm value: char value: ctx];
			onStep: [:char :ctx| ];
			key: '                          '].
	^ SpacesBeforeResourceTrm.! !

!HttpRequestRules class methodsFor: 'heads' stamp: 'NikolayKleptsov 1/20/2013 22:52'!
startHeadsTrm
	StartHeadsTrm isNil ifTrue: [
		StartHeadsTrm := [:char :ctx|
							ctx previousMark; goToMark.
							self hostTrm]].
	^ StartHeadsTrm.
! !

!HttpRequestRules class methodsFor: 'statusLineScanning' stamp: 'NikolayKleptsov 1/20/2013 18:54'!
startTrm
	StartTrm isNil ifTrue: [
		StartTrm := [:char :ctx| ctx previousMark; goToMark. self getTrm]].
	^ StartTrm.! !

!HttpRequestRules class methodsFor: 'heads' stamp: 'NikolayKleptsov 1/20/2013 17:02'!
userAgentTrm
	|t|
	t := [:char :ctx| (char = Character lf)
			ifTrue: [Transcript cr. self hostTrm]
			ifFalse: [Transcript show: char. t] ].
	UserAgentTrm isNil ifTrue: [
		UserAgentTrm := KeyTerminal new.
		UserAgentTrm
			onFailure: [:char :ctx| ctx goToMark. self crLfTrm];
			onSuccess: [:char :ctx| self hostTrm];
			onStep: [:char :ctx| ];
			key: 'User-Agent:'].
	^ UserAgentTrm.
! !

!HttpRequestRules class methodsFor: 'statusLineScanning-version' stamp: 'NikolayKleptsov 1/20/2013 22:49'!
versionTrm
	VersionTrm isNil ifTrue: [
		VersionTrm := KeyTerminal new.
		VersionTrm
			onFailure: [:char :ctx| self heads];
			onSuccess: [:char :ctx| 
							ctx httpVersion: 'HTTP/'.
							self readingVersionTrm];
			onStep: [:char :ctx| ];
			key: 'HTTP/'].
	^ VersionTrm! !

!HttpRequestRules class methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/19/2013 22:05'!
writeToFileBefore: aBoundary
	|sc b b2 f stmEnd|
	stmEnd := ScStatement end.
	b := ABuffer new size: 250.
	b onFullBuffer: [:s| f nextPutAll: s ].
	b2 := ABuffer new size: 100.
	b2 onFullBuffer: [:s2| b nextPutAll: s2].
	Smalltalk at: #tmp put: b.
	Smalltalk at: #tmp2 put: b2.
	Smalltalk at: #tmp3 put: aBoundary.
	sc := KeyTerminal new.
	sc onStep: [:char :file| b2 nextPut: char].
	sc onFailure: [:char :file|
					f := file.
					b2 nextPut: char.
					b2 flushInto: b.
					sc].
	sc onSuccess: [:char :file| b flush. stmEnd].
	sc key: cr, lf, '--', aBoundary, '--'.
	^ sc.! !

Object subclass: #KeyTerminal
	instanceVariableNames: 'onSuccess onFailure onStep first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Scanners'!

!KeyTerminal methodsFor: 'creating' stamp: 'NikolayKleptsov 1/20/2013 11:21'!
key: aKey
	|lsc size sc|
	lsc := Terminal new.
	lsc onFailure: onFailure.
	lsc onSuccess: onSuccess.
	size := aKey size.
	lsc key: (aKey at: size).
	(size - 1) to: 1 by: -1 do: [:index|
		sc := SRTerminal new.
		sc onFailure: onFailure.
		sc onSuccess: onStep.
		sc successResponse: lsc.
		sc key: (aKey at: index).
		lsc := sc].
	first := lsc.! !

!KeyTerminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 23:23'!
onFailure
	^ onFailure! !

!KeyTerminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 23:24'!
onFailure: anFailureAction
	onFailure := anFailureAction! !

!KeyTerminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 23:24'!
onStep
	^ onStep! !

!KeyTerminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 23:24'!
onStep: anStepAction
	onStep := anStepAction! !

!KeyTerminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 23:23'!
onSuccess
	^ onSuccess.! !

!KeyTerminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 23:22'!
onSuccess: anSuccessAction
	onSuccess := anSuccessAction.! !

!KeyTerminal methodsFor: 'scaning' stamp: 'NikolayKleptsov 1/18/2013 00:03'!
value: aChar value: aContext
	^ first value: aChar value: aContext.! !

Object subclass: #MarkReadStream
	instanceVariableNames: 'char stream array index currentIndex marks marked repeat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Web'!

!MarkReadStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/19/2013 22:42'!
array: anArray
	array := anArray.! !

!MarkReadStream methodsFor: 'control' stamp: 'NikolayKleptsov 1/19/2013 23:27'!
goToMark
	marks size > 0
		ifTrue: [currentIndex := marks last - 1].! !

!MarkReadStream methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 1/21/2013 22:05'!
initialize
	array := Array new: 2024.
	index := 0.
	currentIndex := 0.
	marks := OrderedCollection new.
	marked := false.
	repeat := false.! !

!MarkReadStream methodsFor: 'control' stamp: 'NikolayKleptsov 1/19/2013 23:29'!
mark
	marked := true.
	marks addLast: (index +1).! !

!MarkReadStream methodsFor: 'in/out' stamp: 'NikolayKleptsov 1/21/2013 22:08'!
next
	repeat ifTrue: [repeat := false. ^ char].
	^ marked
		ifTrue: [currentIndex = index
					ifTrue: [self nextFromStream]
					ifFalse: [self nextFromArray]]
		ifFalse: [char := stream next].! !

!MarkReadStream methodsFor: 'in/out' stamp: 'NikolayKleptsov 1/20/2013 00:52'!
nextFromArray
	currentIndex := currentIndex +1.
	char := array at: currentIndex.
	^ char.! !

!MarkReadStream methodsFor: 'in/out' stamp: 'NikolayKleptsov 1/19/2013 23:12'!
nextFromStream
	char := stream next.
	currentIndex := index := currentIndex +1.
	array at: currentIndex put: char.
	^ char.! !

!MarkReadStream methodsFor: 'control' stamp: 'NikolayKleptsov 1/20/2013 01:08'!
previousMark
	marked := true.
	((currentIndex = 0) and: [index = 0])
			ifTrue: [currentIndex := index := 1.
					array at: 1 put: char].
	marks addLast: index.! !

!MarkReadStream methodsFor: 'control' stamp: 'NikolayKleptsov 1/21/2013 22:07'!
repeat
	repeat := true! !

!MarkReadStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/19/2013 23:33'!
stream: aStream
	stream := aStream! !

!MarkReadStream methodsFor: 'control' stamp: 'NikolayKleptsov 1/21/2013 22:08'!
unmark
	marks size > 0 ifTrue: [marks removeLast].
	marks size = 0 ifTrue:
					[marked := false.
					currentIndex := index := 0].! !

Object subclass: #NodeScanner
	instanceVariableNames: 'scanner next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!NodeScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/24/2011 23:24'!
scanner
	^ scanner! !

!NodeScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/24/2011 23:28'!
scanner: aScanner
	scanner := aScanner.
	next := aScanner.! !

!NodeScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/24/2011 23:27'!
value: aChar value: anObject
	|res|
	res := scanner value: aChar value: anObject.
	res == #end
		ifTrue: [^ #end]
		ifFalse:[^ self].! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/12/2011 17:34'!
cr
	^ cr! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/12/2011 17:33'!
crlf
	^ crlf! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 00:52'!
defaultResource
	^ '<h1>It works</h1><p>server: StServer</p>'! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 15:57'!
head: aWebRequest
	|r|
	[r := aWebRequest statusLine,
	aWebRequest hServer,
	aWebRequest hContentType,
	crlf.
	aWebRequest sendData: r]
		on: Error do: [:ex|].
	aWebRequest closeAndDestroy.! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 8/12/2011 17:33'!
lf
	^ lf.! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 15:58'!
options: aWebRequest
	|r|	
	[r := aWebRequest statusLine,
	aWebRequest hServer,
	'Allow: GET', lf,
	crlf,
	'<html><head><title>Allow: GET</title><head>',
	'<body><h1>Allow: GET</h1></body></html>'.
	aWebRequest socket sendData: r]
		on: Error
		do: [:ex| ].! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 15:58'!
post: aWebRequest
	^ NotFoundResponse new post: aWebRequest.! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 16:01'!
respondTo: aWebRequest
	|r|
	[r := aWebRequest statusLine,
	aWebRequest hServer,
	aWebRequest hContentType,
	crlf,
	'<html><head><title>', self printString, '</title></head>',
	'<body><p>', self printString, '</p></body></html>'.
	aWebRequest sendData: r]
		on: Error do: [:ex|].
	aWebRequest closeAndDestroy.! !

!Object methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/17/2013 21:38'!
scanByRules: aRuleSequence context: aContext
	|r scProc|
	scProc := ScStatement new.	
	r := aRuleSequence.
	[scProc = r] whileFalse: [
		r := r value: self next value: aContext]! !

Object subclass: #ScStatement
	instanceVariableNames: 'context statement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Scanners'!

!ScStatement class methodsFor: 'creating' stamp: 'NikolayKleptsov 1/17/2013 19:27'!
end
	|obj|
	obj := self new.
	obj statement: [:ctx| true].
	^ obj.! !

!ScStatement methodsFor: 'comparing' stamp: 'NikolayKleptsov 1/17/2013 19:26'!
= anObject
	^ (self class == anObject class)
		ifTrue: [ anObject value: context]
		ifFalse: [false].! !

!ScStatement methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/17/2013 19:12'!
context
	^ context
	! !

!ScStatement methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/17/2013 19:12'!
context: aContext
	context := aContext! !

!ScStatement methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/17/2013 20:59'!
statement: aStatement
	statement := aStatement.! !

!ScStatement methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/17/2013 19:19'!
value: aValue
	^ statement value: aValue! !

!ScStatement methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/19/2013 13:51'!
value: aChar value: aContext! !

Object subclass: #ScannerProcessor
	instanceVariableNames: 'threads scStatement terminal context stream char endScan onScanEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Scanners'!

!ScannerProcessor methodsFor: 'adding&removing' stamp: 'NikolayKleptsov 1/22/2013 23:22'!
addThread: aTerminal
	threads addLast: aTerminal! !

!ScannerProcessor methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/22/2013 23:29'!
char
	^ char! !

!ScannerProcessor methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/22/2013 22:58'!
context
	^ context.! !

!ScannerProcessor methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/22/2013 22:58'!
context: aContext
	context := aContext! !

!ScannerProcessor methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/22/2013 22:57'!
endScan: aBoolean
	endScan := aBoolean.! !

!ScannerProcessor methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 1/22/2013 23:44'!
initialize
	threads := OrderedCollection new.
	scStatement := ScStatement new.
	endScan := false.
	onScanEnd := [:ctx| ].! !

!ScannerProcessor methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/23/2013 00:09'!
scan
	[ 
		self scanChar.
		endScan] whileFalse.
	onScanEnd value: self.
	! !

!ScannerProcessor methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/23/2013 00:16'!
scanChar
	|s|
	s := threads size.
	s = 0 ifTrue: [endScan := true. ^ self].
	char := stream next.
	1 to: s do: [:index|
		terminal := (threads at: index) value: self.
		threads at: index put: terminal].
	threads remove: #end ifAbsent: [ ].! !

!ScannerProcessor methodsFor: 'scanning' stamp: 'NikolayKleptsov 1/22/2013 23:34'!
scanCharacter
	|s|
	s := threads size.
	s = 0 ifTrue: [endScan := true. ^ self].
	char := stream next.
	1 to: s do: [:index|
		terminal := (s at: index) value: self.
		s at: index put: terminal].
	threads remove: #end ifAbsent: [ ].! !

!ScannerProcessor methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/22/2013 22:59'!
stream
	^ stream! !

!ScannerProcessor methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/22/2013 22:59'!
stream: aStream
	stream := aStream! !

Object subclass: #Session
	instanceVariableNames: 'variables timestamp id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Web'!

!Session methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/23/2011 18:01'!
at: anIdentifier
	^ variables at: anIdentifier ifAbsent: [nil].! !

!Session methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/23/2011 17:59'!
at: anIdentifier put: anObject
	variables at: anIdentifier put: anObject.! !

!Session methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/23/2011 17:57'!
id
	^ id! !

!Session methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/23/2011 17:57'!
id: anId
	id := anId! !

!Session methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/23/2011 18:53'!
initialize
	super initialize.
	self initializeVariables.! !

!Session methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/23/2011 17:58'!
initializeVariables
	variables := Dictionary new.! !

!Session methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/23/2011 17:55'!
timestamp
	^ timestamp.! !

!Session methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/23/2011 17:57'!
timestamp: aTimestamp
	timestamp := aTimestamp.! !

Object subclass: #SocketReadStream
	instanceVariableNames: 'onEmpty size array index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Web'!

!SocketReadStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/15/2013 22:25'!
array
	^ array! !

!SocketReadStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/15/2013 22:24'!
index
	^ index.! !

!SocketReadStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/15/2013 22:24'!
index: anIndex
	index := anIndex.! !

!SocketReadStream methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 1/19/2013 22:35'!
initialize
	array := String new: 2024.
	index := 0.
	size := 0.
	onEmpty := [:ers| ers index: 0; size: 0]! !

!SocketReadStream methodsFor: 'in/out' stamp: 'NikolayKleptsov 1/19/2013 22:34'!
next
	index >= size ifTrue: [onEmpty value: self.
						index := 0].
	index := index + 1.
	^ array at: index.! !

!SocketReadStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/15/2013 22:30'!
onEmpty: anEvent
	onEmpty := anEvent.! !

!SocketReadStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/15/2013 22:24'!
size
	^ size.! !

!SocketReadStream methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/15/2013 22:24'!
size: aSize
	size := aSize! !

Object subclass: #TCPServer
	instanceVariableNames: 'process port currentSocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Web'!

!TCPServer methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/7/2013 22:59'!
defaultPort
	^ 8082.! !

!TCPServer methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 1/7/2013 22:58'!
initialize
	super initialize.
	port := 8082.! !

!TCPServer methodsFor: 'serving' stamp: 'NikolayKleptsov 1/17/2013 21:31'!
listenSocket
	|s|
	s := Socket new.
	currentSocket := s.
	s listenOn: port.
	s waitForConnectionFor: (Socket standardTimeout) ifTimedOut: [s].
	s isConnected
		ifTrue: [[self serve: s. s destroy] newProcess
										name: 'StServer connection';
										resume]
		ifFalse: [s destroy]! !

!TCPServer methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/7/2013 23:00'!
port
	port isNil ifTrue: [port := self defaultPort].
	^ port.! !

!TCPServer methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/7/2013 22:58'!
port: aPort
	port := aPort! !

!TCPServer methodsFor: 'serving' stamp: 'NikolayKleptsov 1/7/2013 22:56'!
serve: aSocket! !

!TCPServer methodsFor: 'serving' stamp: 'NikolayKleptsov 1/7/2013 23:44'!
start
	self stop.
	process := [[self listenSocket. true] whileTrue.
			] newProcess.
	process name: 'StServer process'.
	process resume.! !

!TCPServer methodsFor: 'serving' stamp: 'NikolayKleptsov 1/7/2013 23:40'!
stop
	process isNil ifTrue: [^ self].
	process suspend.
	process terminate.
	currentSocket isNil ifFalse: [currentSocket closeAndDestroy].
	process := nil.! !

TCPServer subclass: #WebServer
	instanceVariableNames: 'selectors sessions'
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'StServer-Web'!

WebServer class
	instanceVariableNames: 'Default DefaultPort'!

WebServer class
	instanceVariableNames: 'Default DefaultPort'!

!WebServer class methodsFor: 'services' stamp: 'NikolayKleptsov 8/19/2011 20:43'!
default
	Default isNil ifTrue: [self removeServicesOnPort: self defaultPort.
						Default := self startOn: self defaultPort].
	^ Default.! !

!WebServer class methodsFor: 'services' stamp: 'NikolayKleptsov 8/19/2011 23:40'!
default: aServer
	Default := aServer.! !

!WebServer class methodsFor: 'mime types' stamp: 'NikolayKleptsov 10/8/2011 21:41'!
defaultMimeTypes
	^ #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htc' 'text/x-component'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash')! !

!WebServer class methodsFor: 'heads' stamp: 'NikolayKleptsov 10/16/2011 22:39'!
defaultMimetype
	^  'application/octet-stream'.! !

!WebServer class methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 20:41'!
defaultPort
	DefaultPort isNil ifTrue: [DefaultPort := 8082].
	^ DefaultPort.! !

!WebServer class methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 20:40'!
defaultPort: aPort
	DefaultPort := aPort! !

!WebServer class methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/6/2011 22:29'!
initialize
	super initialize.
	DefaultPort := 8082.
	Smalltalk at: #lf put: String lf.
	Smalltalk at: #cr put: String cr.
	Smalltalk at: #crlf put: String crlf.! !

!WebServer class methodsFor: 'mime types' stamp: 'NikolayKleptsov 10/8/2011 21:46'!
mimeTypes
	|mt|
	MimeTypes ifNil: [
	mt := #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htc' 'text/x-component'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash').
	MimeTypes := Dictionary new.
	1 to: mt size by: 2 do: [:index|
		MimeTypes at: (mt at: index) put: (mt at: index + 1)]].
	^ MimeTypes.! !

!WebServer class methodsFor: 'mime types' stamp: 'NikolayKleptsov 10/16/2011 22:31'!
mimetypes
	|mt|
	MimeTypes ifNil: [
	mt := #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htc' 'text/x-component'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash').
	MimeTypes := Dictionary new.
	1 to: mt size by: 2 do: [:index|
		MimeTypes at: (mt at: index) put: (mt at: index + 1)]].
	^ MimeTypes.! !

!WebServer class methodsFor: 'heads' stamp: 'NikolayKleptsov 1/7/2013 21:55'!
serverName
	^ 'StServer/1.0'! !

!WebServer methodsFor: 'adding & removing' stamp: 'NikolayKleptsov 10/10/2011 21:52'!
at: aSelector

	^ selectors at: aSelector ifAbsent: [self notFound]! !

!WebServer methodsFor: 'adding & removing' stamp: 'NikolayKleptsov 10/10/2011 21:53'!
at: aSelector ifAbsent:  aBlock

	^ selectors at: aSelector ifAbsent: aBlock! !

!WebServer methodsFor: 'adding & removing' stamp: 'NikolayKleptsov 8/19/2011 23:21'!
at: aSelector put:  aWebElement

	selectors isNil ifTrue: [selectors := WebDirectory new].
	selectors at: aSelector put: aWebElement.! !

!WebServer methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/23/2011 17:52'!
initialize

	super initialize.
	self initializeSelectors.
	self initializeNotFound.
	self initializeSessions.! !

!WebServer methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 7/26/2011 22:40'!
initializeNotFound! !

!WebServer methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 8/19/2011 23:31'!
initializeSelectors

	selectors := WebDirectory new rootDirectory.! !

!WebServer methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/23/2011 17:52'!
initializeSessions
	sessions := IdentityDictionary new! !

!WebServer methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/31/2011 22:44'!
selectors
	^ selectors.! !

!WebServer methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/31/2011 22:43'!
selectors: aSelectors
	selectors := aSelectors.! !

!WebServer methodsFor: 'serving' stamp: 'NikolayKleptsov 1/13/2013 22:59'!
serve: aSocket	
	|webReq |	
	[webReq := aSocket webRequest.
	webReq beginToRecognize.
	webReq request: selectors]
			on: Error do: [:ex| 'Server exception:' , ex messageText.
							aSocket closeAndDestroy].! !

Object subclass: #Terminal
	instanceVariableNames: 'key onStep onFailure onSuccess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Scanners'!

Terminal subclass: #FRTerminal
	instanceVariableNames: 'failResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Scanners'!

!FRTerminal methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/20/2013 11:23'!
failResponse
	^ failResponse! !

!FRTerminal methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/20/2013 11:23'!
failResponse: aFailResponse
	failResponse := aFailResponse! !

!FRTerminal methodsFor: 'scaning' stamp: 'NikolayKleptsov 1/22/2013 23:58'!
value: aContext
	^ (key = aContext)
		ifTrue: [onSuccess value: aContext]
		ifFalse: [onFailure value: aContext. failResponse].! !

!FRTerminal methodsFor: 'scaning' stamp: 'NikolayKleptsov 1/20/2013 11:26'!
value: aChar value: ctx
	^ (aChar = key)
		ifTrue: [onSuccess value: aChar value: ctx]
		ifFalse: [onFailure value: aChar value: ctx. failResponse].! !

Terminal subclass: #SRTerminal
	instanceVariableNames: 'successResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Scanners'!

!SRTerminal methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/19/2013 13:29'!
successResponse
	^ successResponse! !

!SRTerminal methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/19/2013 13:30'!
successResponse: aResponse
	successResponse := aResponse! !

!SRTerminal methodsFor: 'scaning' stamp: 'NikolayKleptsov 1/22/2013 23:54'!
value: aContext
	^ (key = aContext char)
		ifTrue: [onSuccess value: aContext.
				successResponse]
		ifFalse: [onFailure value: aContext].! !

!SRTerminal methodsFor: 'scaning' stamp: 'NikolayKleptsov 1/19/2013 13:35'!
value: aChar value: aContext
	^ (key = aChar)
		ifTrue: [onSuccess value: aChar value: aContext.
				successResponse]
		ifFalse: [onFailure value: aChar value: aContext].! !

!Terminal methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/17/2013 22:33'!
key
	^ key! !

!Terminal methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/17/2013 22:32'!
key: aKey
	key := aKey! !

!Terminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 22:34'!
onFailure
	^ onFailure! !

!Terminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 22:34'!
onFailure: onFailureBlock
	onFailure := onFailureBlock! !

!Terminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 22:35'!
onSuccess
	^ onSuccess! !

!Terminal methodsFor: 'events' stamp: 'NikolayKleptsov 1/17/2013 22:35'!
onSuccess: anSuccessBlock
	onSuccess := anSuccessBlock! !

!Terminal methodsFor: 'scaning' stamp: 'NikolayKleptsov 1/22/2013 23:51'!
value: aContext
	^ (key = aContext char)
		ifTrue: [onSuccess value: aContext]
		ifFalse: [onFailure value: aContext].! !

!Terminal methodsFor: 'scaning' stamp: 'NikolayKleptsov 1/20/2013 20:25'!
value: aChar value: aContext
	|t|
	(key = aChar)
		ifTrue: [t := onSuccess value: aChar value: aContext]
		ifFalse: [t := onFailure value: aChar value: aContext].
	^ t.! !

Object subclass: #TerminalScanner
	instanceVariableNames: 'char nextScanner successfulRecognition failureRecognition successStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

TerminalScanner subclass: #LastTerminalScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!LastTerminalScanner methodsFor: 'recognition' stamp: 'NikolayKleptsov 8/20/2011 17:17'!
value: aChar value: aContext
	aChar == char
		ifTrue: [^ successfulRecognition value: aChar value: aContext]
		ifFalse: [^ failureRecognition value: aChar value: aContext].! !

!TerminalScanner methodsFor: 'recognition' stamp: 'NikolayKleptsov 8/16/2011 14:10'!
addTerminal: aTerminal
	aTerminal size = 0 ifTrue: [Error signal: 'Incorrect terminal string'].
	self addTerminal: aTerminal index: 1.! !

!TerminalScanner methodsFor: 'recognition' stamp: 'NikolayKleptsov 8/18/2011 17:20'!
addTerminal: aTerminal index: anIndex
	char := aTerminal at: anIndex.
	anIndex +1 = aTerminal size
		ifTrue: [	nextScanner := LastTerminalScanner new.
				nextScanner from: self.
				nextScanner char: (aTerminal at: anIndex + 1)]
		ifFalse: [nextScanner := TerminalScanner new.
				nextScanner from: self.
				nextScanner addTerminal: aTerminal index: anIndex + 1]
	! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 08:38'!
char
	^ char! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 08:37'!
char: aChar
	char := aChar! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 08:41'!
failureRecognition
	^ failureRecognition! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 13:35'!
failureRecognition: aBlock
	failureRecognition := aBlock! !

!TerminalScanner methodsFor: 'recognition' stamp: 'NikolayKleptsov 8/19/2011 17:36'!
from: aScanner
	self successfulRecognition: aScanner successfulRecognition.
	self failureRecognition: aScanner failureRecognition.
	self successStep: aScanner successStep.! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 08:39'!
nextScanner
	^ nextScanner! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 08:39'!
nextScanner: aScanner
	nextScanner := aScanner! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 17:34'!
successStep
	^ successStep! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 17:34'!
successStep: aBlock
	successStep := aBlock! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 08:40'!
successfulRecognition
	^ successfulRecognition! !

!TerminalScanner methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/16/2011 08:41'!
successfulRecognition: aBlock
	successfulRecognition := aBlock! !

!TerminalScanner methodsFor: 'recognition' stamp: 'NikolayKleptsov 8/20/2011 17:16'!
value: aChar value: aContext
	aChar == char
		ifTrue: [successStep value: aChar value: aContext.
				^ nextScanner.]
		ifFalse: [^ failureRecognition value: aChar value: aContext].! !

Object subclass: #WebRequest
	instanceVariableNames: 'method path pathIndex resource boundary stream markStream fileName socket statusCode httpVersion hServer hContentType hHost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Web'!

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/29/2011 21:04'!
addCharacterAtBoundary: aChar

	boundary := boundary , aChar asString.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/3/2011 22:12'!
addCharacterAtFileName: aCharacter

	fileName := fileName, aCharacter asString.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/30/2011 19:01'!
addCharacterAtPath: aChar

	| t |
	
	t := path removeLast.
	t := t, aChar asString.
	path addLast: t.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/29/2011 18:40'!
addCharacterAtResource: aChar

	resource := resource , aChar asString.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/21/2011 14:04'!
addPath

	path addLast: ''.! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/20/2013 01:20'!
beginToRecognize
	path removeAllSuchThat: [:el| el =''].
	markStream scanByRules: (HttpRequestRules startTrm)
			context: self.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/27/2011 20:05'!
boundary

	^ boundary! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/27/2011 20:04'!
boundary: aBoundary

	boundary := aBoundary! !

!WebRequest methodsFor: 'closing' stamp: 'NikolayKleptsov 8/19/2011 20:25'!
closeAndDestroy
	socket closeAndDestroy! !

!WebRequest methodsFor: 'requesting' stamp: 'NikolayKleptsov 8/20/2011 18:30'!
currentResourceSelector
	^ path at: pathIndex.! !

!WebRequest methodsFor: 'html' stamp: 'NikolayKleptsov 8/21/2011 01:13'!
directoryHrefOf: aResourceSelector
	^ '<a href="',
	self stringPath, '/',
	aResourceSelector, '/">',
	aResourceSelector, '/</a>'.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/3/2011 22:09'!
fileName

	^ fileName.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/3/2011 22:09'!
fileName: aFileName

	fileName := aFileName.! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/19/2013 23:59'!
goToMark
	markStream goToMark.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:35'!
hContentType
	hContentType isNil ifTrue: [hContentType := 'text/html'].
	^ 'ContentType: ', hContentType, lf! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:36'!
hContentType: aContentType
	hContentType := aContentType.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/20/2013 22:14'!
hHost
	hHost isNil ifTrue: [hHost := '' ].
	^ hHost.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/20/2013 22:13'!
hHost: aHost
	hHost := aHost.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:35'!
hServer
	hServer isNil ifTrue: [hServer := 'StServer' ].
	^ 'Server: ', hServer, lf.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:26'!
hServer: aServerName
	hServer := aServerName.! !

!WebRequest methodsFor: 'html' stamp: 'NikolayKleptsov 8/21/2011 01:14'!
hrefOf: aResourceSelector
	^ '<a href="',
	self stringPath, '/',
	aResourceSelector, '">',
	aResourceSelector, '</a>'.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:16'!
httpVersion
	httpVersion isNil ifTrue: [httpVersion := 'HTTP/1.0'].
	^ httpVersion.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:15'!
httpVersion: aVersion
	httpVersion := aVersion.! !

!WebRequest methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 8/21/2011 14:03'!
initialize

	super initialize.
	path := OrderedCollection new.
	path addLast: ''.
	pathIndex := 0.
	resource := ''.
	boundary := ''.
	fileName := ''.! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/19/2013 23:58'!
mark
	markStream mark.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/19/2013 23:57'!
markStream
	^ markStream.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/27/2011 20:02'!
method

	^ method! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/27/2011 20:02'!
method: aMethod

	method := aMethod! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/29/2011 18:55'!
moveResourceToPath

	path := path, resource, '/'.
	resource := ''.! !

!WebRequest methodsFor: 'receivingAndSending' stamp: 'NikolayKleptsov 1/20/2013 00:01'!
next
	^ markStream next! !

!WebRequest methodsFor: 'requesting' stamp: 'NikolayKleptsov 8/21/2011 14:21'!
nextResourceSelector
	|index|
	pathIndex = path size
		ifTrue: [index := 'defaultResource']
		ifFalse: [pathIndex := pathIndex + 1.
				index := path at: pathIndex].
	index = '' ifTrue: [index := 'defaultResource'.
					pathIndex := pathIndex -1].
	^ index.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/23/2011 21:49'!
outCookies
	^ 'set-cookie: session=1; path=/'! !

!WebRequest methodsFor: 'html' stamp: 'NikolayKleptsov 8/21/2011 01:13'!
parentDirectoryHref
	^ '<a href="',
	self stringParentPath, '/',
	'">parent directory</a>'.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/27/2011 20:03'!
path

	^ path! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/27/2011 20:03'!
path: aPath

	path := aPath! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/20/2013 01:16'!
previousMark
	markStream previousMark.! !

!WebRequest methodsFor: 'receivingAndSending' stamp: 'NikolayKleptsov 1/17/2013 21:41'!
receive
	stream scanByRules: (HttpRequestRules firstLine)
			context: self.! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/17/2013 21:41'!
recognizeAndWriteToFile: aFile
	self scanByRules: (HttpRequestRules writeToFileBefore: boundary)
		context: aFile.! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/17/2013 21:41'!
recognizeDoubleCrlf
	self scanByRules: (HttpRequestRules doubleCrlf)
		context: nil.! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/17/2013 21:40'!
recognizeFileName
	self scanByRules: (HttpRequestRules fileName)
		context: self.! !

!WebRequest methodsFor: 'requesting' stamp: 'NikolayKleptsov 1/8/2013 22:46'!
request: aWebResponse
	^ aWebResponse perform: method with: self.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/27/2011 20:03'!
resource

	^ resource! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 7/27/2011 20:04'!
resource: aResource

	resource := aResource! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/17/2013 21:44'!
scanByRules: aRules context: aContext
	stream scanByRules: aRules context: aContext.! !

!WebRequest methodsFor: 'receivingAndSending' stamp: 'NikolayKleptsov 1/20/2013 00:00'!
sendData: aData
	^ socket sendData: aData.! !

!WebRequest methodsFor: 'receivingAndSending' stamp: 'NikolayKleptsov 8/19/2011 20:26'!
sendStreamContents: aStream
	socket sendStreamContents: aStream.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/19/2011 20:24'!
socket

	^ socket.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/19/2013 23:55'!
socket: aSocket
	stream := aSocket asBufferStream.
	markStream := MarkReadStream new.
	markStream stream: stream.
	socket := aSocket.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:14'!
statusCode
	statusCode isNil ifTrue: [statusCode := '200' ].
	^ statusCode.
! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:16'!
statusCode: aStatusCode
	statusCode := aStatusCode.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:23'!
statusLine
	^ self httpVersion, ' ', self statusCode, ' ', 'OK', lf.! !

!WebRequest methodsFor: 'heads' stamp: 'NikolayKleptsov 1/13/2013 12:19'!
statusLine: aStatusLine
! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/2/2011 22:28'!
stream

	^ stream! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/21/2011 01:08'!
stringParentPath
	|p|
	p := ''.
	1 to: (pathIndex - 1) do: [:el| p :=p , '/', (path at: el)].
	^ p.! !

!WebRequest methodsFor: 'accessing' stamp: 'NikolayKleptsov 8/20/2011 23:41'!
stringPath
	|p|
	p := ''.
	1 to: pathIndex do: [:el| p :=p , '/', (path at: el)].
	^ p.! !

!WebRequest methodsFor: 'recognizing' stamp: 'NikolayKleptsov 1/19/2013 23:59'!
unmark
	markStream unmark! !

Object subclass: #WebResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Web'!

WebResponse subclass: #DirectoryBrowserResponse
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!DirectoryBrowserResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 1/1/2012 19:58'!
allowPost: aWebRequest

	|file|
	
	[aWebRequest 	recognizeFileName.
	aWebRequest 	recognizeDoubleCrlf.
	file := self directory forceNewFileNamed: aWebRequest fileName.
	file writeFromWebRequest: aWebRequest.
	self respondTo: aWebRequest] on: Error do: [:ex| Transcript show: 'error file upload: ', ex messageText; cr].
	aWebRequest closeAndDestroy.! !

!DirectoryBrowserResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 8/21/2011 16:58'!
disablePost: aWebRequest

	|r f|
	
	aWebRequest 	recognizeFileName.
	aWebRequest 	recognizeDoubleCrlf.
	f := FileEmulator new.
	f writeFromWebRequest: aWebRequest.
	self respondTo: aWebRequest.
	"r :=
	'HTTP/1.0 200 OK', lf,
	'Server: SmalltalkServer/1.0', lf,
	'Content-Type: text/html', lf
	crlf.
	aWebRequest sendData: r.
	aWebRequest closeAndDestroy."! !

!DirectoryBrowserResponse methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/13/2013 12:06'!
path
	^ path! !

!DirectoryBrowserResponse methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/13/2013 12:05'!
path: aPath
	path := aPath! !

!DirectoryBrowserResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 8/21/2011 16:39'!
post: aWebRequest

	(self directory fileExists: '.allowPost.web')
		ifTrue: [self allowPost: aWebRequest]
		ifFalse: [self disablePost: aWebRequest].! !

!DirectoryBrowserResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 1/13/2013 13:15'!
respondTo: aWebRequest
	|r stream|
	r := aWebRequest statusLine,
	aWebRequest hServer,
	'Allow: GET, POST', lf,
	'Content-Type: text/html; charset=utf-8' ,lf,
	crlf.
	aWebRequest sendData: r.
	r := '<html><head><title>', aWebRequest currentResourceSelector,
	'</title></head><body>',
	"self upload,"
	'<h4>Index of ', aWebRequest stringPath,'</h4>',
	aWebRequest parentDirectoryHref, '<br>'.
	path asFileReference directories do: [:el|
		r := r, (aWebRequest directoryHrefOf: el entry baseName) , '<br>'].
	path asFileReference files do: [:el|
		r := r, (aWebRequest hrefOf: el entry baseName), '<br>'].
	r := r, '</body></html>'.
	aWebRequest sendData: r asUTF8.
	aWebRequest closeAndDestroy.
	! !

!DirectoryBrowserResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 1/13/2013 16:18'!
upload
	|r|
	(self directory fileExists: '.allowPost.web') ifFalse: [^ ''].
	r :=
	'<form enctype="multipart/form-data" method="post">',
		'<h4>Upload your file</h4>',
		'<p><input type="file" name="f">',
			'<input type="submit" value="upload"></p>',
	'</form>'.
	^ r.! !

WebResponse subclass: #NotFoundResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Web'!

!NotFoundResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 1/13/2013 12:54'!
respondTo: aWebRequest
	| r |	
	[r := 'HTTP/1.0 404 Not Found', lf,
	aWebRequest hServer,
	aWebRequest hContentType,
	crlf,
	'<html><head><title>404 Not Found</title></head>',
	'<body><h1>Not Found</h1><p>Resource not found. Server: StServer</body></html>'.
	aWebRequest sendData: r]
		on: Error do: [:ex| ].
	aWebRequest closeAndDestroy.! !

WebResponse subclass: #WebDirectory
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Web'!

!WebDirectory methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/13/2013 17:43'!
at: aSelector
	^ dictionary at: aSelector! !

!WebDirectory methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/13/2013 17:43'!
at: aSelector ifAbsent: aBlock
	^ dictionary at: aSelector ifAbsent: aBlock! !

!WebDirectory methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/13/2013 17:43'!
at: aSelector put: aWebResponse
	^ dictionary at: aSelector put: aWebResponse.! !

!WebDirectory methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/13/2013 17:43'!
dictionary
	^ dictionary! !

!WebDirectory methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 1/13/2013 17:43'!
initialize
	super initialize.
	dictionary := Dictionary new.! !

!WebDirectory methodsFor: 'responding' stamp: 'NikolayKleptsov 1/13/2013 17:43'!
options: aWebRequest
	| socket r|	
	aWebRequest path size = 0
		ifTrue: [self optionsWebDirectory: aWebRequest]
		ifFalse: [self respondTo: aWebRequest].! !

!WebDirectory methodsFor: 'responding' stamp: 'NikolayKleptsov 1/13/2013 17:45'!
optionsWebDirectory: aWebRequest
	|r|
	r := aWebRequest statusLine,
	aWebRequest hServer,
	'Allow: GET, POST', lf,
	crlf,
	'<html><head><title>Allow: GET, POST</title><head>',
	'<body><h1>Allow: GET, POST</h1></body></html>'.
	aWebRequest sendData: r.! !

!WebDirectory methodsFor: 'responding' stamp: 'NikolayKleptsov 10/10/2011 10:47'!
post: aWebRequest
	self respondTo: aWebRequest! !

!WebDirectory methodsFor: 'responding' stamp: 'NikolayKleptsov 1/13/2013 00:46'!
respondTo: aWebRequest
	|r|	
	r := aWebRequest nextResourceSelector.
	r = 'defaultResource'
		ifTrue: [r := self defaultResource]
		ifFalse: [r := self at: r ifAbsent: [self notFound]].
	aWebRequest request: r.! !

!WebDirectory methodsFor: 'creating' stamp: 'NikolayKleptsov 10/10/2011 10:47'!
rootDirectory
	dictionary removeAll.
	^ self.! !

WebResponse subclass: #WebFileDirectory
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!WebFileDirectory methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/10/2011 10:42'!
absoluteDirectory
	directory absoluteDirectory! !

!WebFileDirectory methodsFor: 'responding' stamp: 'NikolayKleptsov 10/10/2011 10:44'!
directory
	^ directory directory.! !

!WebFileDirectory methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 8/19/2011 23:57'!
initialize
	super initialize.
	self initializeDirectory.! !

!WebFileDirectory methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/10/2011 10:42'!
initializeDirectory
	directory := Directory new! !

!WebFileDirectory methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/10/2011 10:43'!
path
	^ directory path.! !

!WebFileDirectory methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/10/2011 10:43'!
path: aPath
	directory path: aPath.! !

!WebFileDirectory methodsFor: 'responding' stamp: 'NikolayKleptsov 10/10/2011 10:44'!
post: aWebRequest
	aWebRequest request: self directory.! !

!WebFileDirectory methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/10/2011 10:42'!
relativeDirectory
	directory relativeDirectory.! !

!WebFileDirectory methodsFor: 'responding' stamp: 'NikolayKleptsov 10/10/2011 10:45'!
respondTo: aWebRequest
	aWebRequest request: self directory.! !

WebFileDirectory subclass: #WebStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!WebStream methodsFor: 'responding' stamp: 'NikolayKleptsov 8/12/2011 18:58'!
respondTo: aWebRequest

	|dir f1 f2 r|
	
	dir := FileDirectory default directoryNamed: path.
	f1 := dir readOnlyFileNamed: '001'.
	r :=
	'HTTP/1.0 200 OK', lf,
	self serverNameHead, lf,
	'Content-Type: ', 'video/x-ms-wmv', lf,
	'Content-Length: ', '-1', lf,
	crlf.
	aWebRequest sendData: r.
	aWebRequest sendStreamContents: f1.
	f2 := dir readOnlyFileNamed: '002'.
	aWebRequest sendStreamContents: f2.
	aWebRequest closeAndDestroy.! !

WebResponse subclass: #WebFileResponse
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!WebFileResponse methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/12/2013 23:38'!
fileName
	^ fileName! !

!WebFileResponse methodsFor: 'accessing' stamp: 'NikolayKleptsov 1/12/2013 23:38'!
fileName: aFileName
	fileName := aFileName! !

!WebFileResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 1/12/2013 23:45'!
respondTo: aWebRequest
	|file|	
	file := FileReference fileSystem: (FileSystem disk) path: fileName.
	file := file readStream.
	"file := FileSystem disk readStreamOn: fileName."
	aWebRequest request: file! !

!WebResponse methodsFor: 'heads' stamp: 'NikolayKleptsov 8/3/2011 17:22'!
allowHead

	^ 'Allow: GET, POST, OPTIONS'.! !

!WebResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 10/6/2011 22:23'!
notAllow: aWebRequest

	|r|
	
	[r := 'HTTP/1.0 501 Not Implemented', lf,
	self serverNameHead, lf,
	'Allow: GET, POST', lf,
	crlf,
	'<html><head><title>Allow: GET, POST</title><head>',
	'<body><h1>Allow: GET, POST</h1></body></html>'.
	aWebRequest sendData: r]
		on: Error do: [:ex| ].
	aWebRequest closeAndDestroy.! !

!WebResponse methodsFor: 'responding' stamp: 'NikolayKleptsov 1/13/2013 00:47'!
notFound
	^ NotFoundResponse new.! !

!WebResponse methodsFor: 'heads' stamp: 'NikolayKleptsov 8/3/2011 17:17'!
serverNameHead

	^ 'Server: ', WebServer serverName.! !

WebResponse subclass: #WebUpload
	instanceVariableNames: 'uploadForm directory onFileNameRead onUpload'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StServer-Temp'!

!WebUpload methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/10/2011 10:58'!
absoluteDirectory
	directory ifNil: [directory := Directory new].
	directory absoluteDirectory.! !

!WebUpload methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/10/2011 10:53'!
directory
	^ directory directory.! !

!WebUpload methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/10/2011 10:55'!
initialize
	super initialize.
	self relativeDirectory.
	self initializeUploadForm.
	self initializePath.
	self initializeOnUpload.
	self initializeOnFileNameRead.! !

!WebUpload methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/8/2011 19:40'!
initializeOnFileNameRead
	onFileNameRead := [:arg| ].! !

!WebUpload methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/8/2011 19:19'!
initializeOnUpload
	onUpload := [:arg| ].! !

!WebUpload methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/7/2011 23:50'!
initializePath
	self path: ''.! !

!WebUpload methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/8/2011 00:00'!
initializeUploadForm
self uploadForm: 
	'HTTP/1.0 200 OK', lf,
	'Server: SmalltalkServer/1.0', lf,
	'Content-Type: text/html', lf,
	crlf,
	'<html><head><title>File upload</title></head>',
	'<body>',
	'<form enctype="multipart/form-data" method="post">',
	'Upload your file',
	'<p><input type="file" name="f">',
	'<input type="submit" value="send"></p>',
	'</form>',
	'</body>',
	'</html>'.! !

!WebUpload methodsFor: 'actions' stamp: 'NikolayKleptsov 10/8/2011 20:55'!
onFileNameRead
	onFileNameRead value: self.! !

!WebUpload methodsFor: 'actions' stamp: 'NikolayKleptsov 10/8/2011 19:04'!
onFileNameRead: anAction! !

!WebUpload methodsFor: 'actions' stamp: 'NikolayKleptsov 10/8/2011 20:55'!
onUpload
	onUpload value: self.! !

!WebUpload methodsFor: 'actions' stamp: 'NikolayKleptsov 10/8/2011 19:18'!
onUpload: anAction! !

!WebUpload methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/10/2011 10:52'!
path
	^ directory path! !

!WebUpload methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/10/2011 10:52'!
path: aPath
	directory path: aPath.! !

!WebUpload methodsFor: 'responding' stamp: 'NikolayKleptsov 10/8/2011 21:12'!
post: aWebRequest
	|file|
	[aWebRequest recognizeFileName.
	self onFileNameRead.
	
	aWebRequest recognizeDoubleCrlf.
	file := self directory forceNewFileNamed: aWebRequest fileName.
	file writeFromWebRequest: aWebRequest.
	aWebRequest sendData: self uploadForm.
	self onUpload] on: Error do: [:ex| ].
	
	aWebRequest closeAndDestroy.! !

!WebUpload methodsFor: 'initialize-release' stamp: 'NikolayKleptsov 10/10/2011 10:58'!
relativeDirectory
	directory ifNil: [directory := Directory new].
	directory relativeDirectory.! !

!WebUpload methodsFor: 'responding' stamp: 'NikolayKleptsov 10/7/2011 23:39'!
respondTo: aWebRequest
	aWebRequest sendData: self uploadForm.
	aWebRequest closeAndDestroy.! !

!WebUpload methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/7/2011 23:36'!
uploadForm
	^ uploadForm.! !

!WebUpload methodsFor: 'accessing' stamp: 'NikolayKleptsov 10/7/2011 23:36'!
uploadForm: aForm
	uploadForm := aForm.! !

!Path methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 11:25'!
asOrderedCollection
	|c|
	c := OrderedCollection new.
	self do: [:el| c addLast: el].
	^ c! !

!Path methodsFor: '*StServer' stamp: 'NikolayKleptsov 1/13/2013 13:39'!
newPlus: aSegmentOrFileName
	|c|
	c := self asOrderedCollection.
	c addLast: aSegmentOrFileName.
	^ self class withAll: c.! !
WebServer initialize!
